package cn.net.caoyao.cpzshandset.service.thread.impl.liqueur;

import java.io.IOException;
import java.net.BindException;
import java.net.ConnectException;
import java.net.SocketTimeoutException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.List;

import android.os.Handler;
import android.os.Message;
import cn.net.caoyao.cpzshandset.bean.SingleLabelOptionBean;
import cn.net.caoyao.cpzshandset.bean.UploadBean;
import cn.net.caoyao.cpzshandset.bean.WarehouseBean;
import cn.net.caoyao.cpzshandset.common.config.Config;
import cn.net.caoyao.cpzshandset.common.config.HandsetOperation;
import cn.net.caoyao.cpzshandset.common.config.InternalOptionConstant;
import cn.net.caoyao.cpzshandset.common.config.RequestConstant;
import cn.net.caoyao.cpzshandset.common.config.TConfig;
import cn.net.caoyao.cpzshandset.common.util.LogUtil;
import cn.net.caoyao.cpzshandset.service.bll.SingleLabelBll;
import cn.net.caoyao.cpzshandset.service.bll.UploadStatusBll;
import cn.net.caoyao.cpzshandset.service.bll.WarehouseBll;
import cn.net.cpzslibs.prot.Prot02Logout;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.bean.res.ProtStatusResBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20017ReqBean;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20035ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20017LabelBean;
import cn.net.cpzslibs.prot.handset.newProt.Prot20017CheckLabelStatus;
import cn.net.cpzslibs.prot.handset.newProt.Prot20035LabelOption;

public class LiqueurSubmitAllWarehouseThread implements Runnable {
	private long deviceId;
	private WarehouseBll bll;
	private SingleLabelBll labelBll;
	private UploadStatusBll uploadStatusBll;
	private Handler mHandler;
	private HandsetOperation option_type;
	private List<WarehouseBean> warehouseBeans;

	public LiqueurSubmitAllWarehouseThread(Handler mHandler,long deviceId,WarehouseBll bll,SingleLabelBll labelBll,UploadStatusBll uploadStatusBll,HandsetOperation option_type,List<WarehouseBean> warehouseBeans) {
		this.mHandler = mHandler;
		this.deviceId = deviceId;
		this.bll = bll;
		this.labelBll = labelBll;
		this.uploadStatusBll = uploadStatusBll;
		this.option_type = option_type;
		this.warehouseBeans = warehouseBeans;
//		LogUtil.d(TConfig.Echo, "出库数据：" + warehouseBeans.toString());
	}

	@Override
	public void run() {
		SocketCreate create = new SocketCreate(Config.ip, Config.port, "");
		try {
			LogUtil.d(TConfig.Echo, "登录");
			create.createLoginCpzsHandset(deviceId);
			if (create.isResult()) {
				submitWarehouseInfo(create);
			} else {
				Message msg = new Message();
				msg.what = RequestConstant.REQUEST_PROT01_LOGIN_FAIL;
				msg.arg1 = create.getiErrCode();
				msg.obj = create.getErrMsg();
				mHandler.sendMessage(msg);
			}
			
		} catch (BindException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (ConnectException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (SocketTimeoutException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL_SOCKET_TIMEOUT);
		} catch (UnknownHostException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		} catch (IOException e) {
			e.printStackTrace();
			mHandler.sendEmptyMessage(RequestConstant.REQUEST_FAIL);
		}finally {
			new Prot02Logout().dealLogout(create);
		}
	}


	private void submitWarehouseInfo(SocketCreate create) throws IOException{
		for (WarehouseBean b : warehouseBeans) {
			int count = labelBll.queryLabelCountById(option_type.getOption(), b.getId());
			if (count > 0) {
				Prot20035LabelOption labelOption = new Prot20035LabelOption();
				labelOption.submitLabelOptionInfo(create, getProt20035ReqBean(b));
				
				
				ProtStatusResBean resBean = labelOption.getResBean();
				if (resBean != null ) {
					if (resBean.getResult() == 0) {
						//成功
						uploadStatusBll.insertUploadStatus(getUploadBean(b));
						bll.deleteWarehouse(b);
					} else {
						//失败
//						bll.updateWarehouseErrorStatus(status, error_code, id);
						bll.updateWarehouseErrorStatus(Config.SUBMIT_STATUS_SUBMIT_FAIL, resBean.getErrcode(), b.getId());
						checkLabel(create, b);
					}
				}
				
			}
		}
		
		mHandler.sendEmptyMessage(RequestConstant.SUBMIT_ALL_WAREHOUSE_COMPLETE);
	}
	
	private void checkLabel(SocketCreate create,WarehouseBean b) throws IOException{
		Prot20017CheckLabelStatus prot20017 = new Prot20017CheckLabelStatus();
		prot20017.checkLabel(create, getProt20017ReqBean(b));
		if (prot20017.getResBean() != null && prot20017.getResBean().getResult() == 0) {
			List<Prot20017LabelBean> invilad = prot20017.getResBean().getLabel_invalid();
			if (invilad != null) {
				List<String> inviladLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : invilad) {
					inviladLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(inviladLabel, option_type.getOption(), b.getId(), InternalOptionConstant.SINGLE_LABEL_STATUS_INVALID);
			}
			
			List<Prot20017LabelBean> noActivate = prot20017.getResBean().getLabel_not_active();
			if (noActivate != null) {
				List<String> noActivateLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : noActivate) {
					noActivateLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(noActivateLabel, option_type.getOption(), b.getId(), InternalOptionConstant.SINGLE_LABEL_STATUS_NO_ACTIVATE);
			}
			
			List<Prot20017LabelBean> label_stack_out = prot20017.getResBean().getLabel_stock_out();
			if (label_stack_out != null) {
				List<String> stackOutLabel = new ArrayList<>();
				for (Prot20017LabelBean prot20017LabelBean : label_stack_out) {
					stackOutLabel.add(prot20017LabelBean.getLabel_id());
				}
				labelBll.updateLableStatusById(stackOutLabel, option_type.getOption(), b.getId(), InternalOptionConstant.SINGLE_LABEL_STATUS_STACK_OUT_REPEAT);
			}
		}
		
	}

	private Prot20017ReqBean getProt20017ReqBean(WarehouseBean b) {
		Prot20017ReqBean reqBean = new Prot20017ReqBean();
		reqBean.setLabels(getLabels(b));
		reqBean.setOpt(getOptType());
		return reqBean;
	}
	
	//操作类型1-出库 2-入库 3-销售 4-返库 6-打包 8-激活
		private int getOptType() {
			int opt = 0;
			switch (option_type) {
			case OPERATION_ACTIVATE_CONSTANT:
				opt = 8;
				break;
			case OPERATION_OUT_WAREHOUSE_CONSTANT:
				opt = 10;
				break;
			case OPERATION_IN_WAREHOUSE_CONSTANT:
				opt = 2;
				break;
			case OPERATION_SALE_CONSTANT:
				opt = 10;
				break;
			case OPERATION_BACK_WAREHOUSE_CONSTANT:
				opt = 4;
				break;
			case OPERATION_PACK_CONSTANT:
				opt = 6;
				break;
			}
			return opt;
		}

	private Prot20035ReqBean getProt20035ReqBean(WarehouseBean wb) {
		Prot20035ReqBean p = new Prot20035ReqBean();
		p.setLabels(getLabels(wb));
		p.setOpt_description(wb.getDescribe());
		p.setOpt(1);//1-出库 2-入库 3-销售 4-返库 5-采集 6-运输 7-贮藏
		p.setSales_area(wb.getSale_area_code());
		p.setPlan_num(wb.getPlan_num());
//		LogUtil.e(TConfig.Echo, "出库p:"+p.toString());
		return p;
	}


	private UploadBean getUploadBean(WarehouseBean wBean) {
		UploadBean b = new UploadBean();
		b.setLabel_count(labelBll.queryLabelCountById(option_type.getOption(), wBean.getId()));
		b.setOption_type(option_type.getOption());
		return b;
	}


	private List<String> getLabels(WarehouseBean wBean) {
		List<String> singles = new ArrayList<>();
		List<SingleLabelOptionBean> singleOptions = labelBll.queryAllLabelById(option_type.getOption(), wBean.getId());
		for (SingleLabelOptionBean sLBean : singleOptions) {
			singles.add(sLBean.getLabel_id());
		}
		return singles;
	}


}
